diff --git a/drivers/usb/function/msm_hsusb.c b/drivers/usb/function/msm_hsusb.c
index 83b97ea..afda4d9 100644
--- a/drivers/usb/function/msm_hsusb.c
+++ b/drivers/usb/function/msm_hsusb.c
@@ -196,6 +196,8 @@ struct usb_info {
 
 	struct clk *clk;
 	struct clk *pclk;
+
+	struct dentry *dent;
 };
 
 struct usb_device_descriptor desc_device = {
@@ -397,6 +399,7 @@ fail2:
 fail1:
 	return 0;
 }
+EXPORT_SYMBOL(usb_ept_alloc_req);
 
 static void do_free_req(struct usb_info *ui, struct msm_request *req)
 {
@@ -406,6 +409,7 @@ static void do_free_req(struct usb_info *ui, struct msm_request *req)
 	dma_pool_free(ui->pool, req->item, req->item_dma);
 	kfree(req);
 }
+EXPORT_SYMBOL(do_free_req);
 
 void usb_ept_free_req(struct usb_endpoint *ept, struct usb_request *_req)
 {
@@ -424,6 +428,7 @@ void usb_ept_free_req(struct usb_endpoint *ept, struct usb_request *_req)
 	if (!dead)
 		do_free_req(ui, req);
 }
+EXPORT_SYMBOL(usb_ept_free_req);
 
 static void usb_ept_enable(struct usb_endpoint *ept, int yes)
 {
@@ -559,6 +564,7 @@ int usb_ept_queue_xfer(struct usb_endpoint *ept, struct usb_request *_req)
 	spin_unlock_irqrestore(&ui->lock, flags);
 	return 0;
 }
+EXPORT_SYMBOL(usb_ept_queue_xfer);
 
 int usb_ept_flush(struct usb_endpoint *ept)
 {
@@ -566,11 +572,13 @@ int usb_ept_flush(struct usb_endpoint *ept)
 	flush_endpoint(ept);
 	return 0;
 }
+EXPORT_SYMBOL(usb_ept_flush);
 
 int usb_ept_get_max_packet(struct usb_endpoint *ept)
 {
 	return ept->max_pkt;
 }
+EXPORT_SYMBOL(usb_ept_get_max_packet);
 
 /* --- endpoint 0 handling --- */
 
@@ -923,50 +931,6 @@ static void flush_all_endpoints(struct usb_info *ui)
 		flush_endpoint_sw(ui->ept + n);
 }
 
-/* add usb_connected notify behavior ===== */
-static DEFINE_MUTEX(notify_sem);
-static atomic_t atomic_usb_connected = ATOMIC_INIT(0);
-static struct work_struct usb_connect_notifier_wq;
-
-static void send_usb_connect_notify(struct work_struct *send_usb_wq)
-{
-	static struct t_usb_status_notifier *notifier = NULL;
-	mutex_lock(&notify_sem);
-	list_for_each_entry(notifier, &g_lh_usb_notifier_list, notifier_link)	{
-		if (notifier->func != NULL)	{
-			/* Notify other drivers about USB online. */
-			notifier->func(atomic_read(&atomic_usb_connected));
-		}
-	}
-	mutex_unlock(&notify_sem);
-}
-
-int usb_register_notifier(struct t_usb_status_notifier *notifier)
-{
-	if (!notifier || !notifier->name || !notifier->func)
-		return -EINVAL;
-
-	mutex_lock(&notify_sem);
-	list_add(&notifier->notifier_link,
-		&g_lh_usb_notifier_list);
-	mutex_unlock(&notify_sem);
-	return 0;
-}
-
-#ifdef MSM_HSUSB_SHOW_USB_NOTIFIER_MESSAGE
-static void usb_notify_connected(int connected)
-{
-	printk(KERN_DEBUG "\n\n%s() RUN(%d)...............\n\n\n",
-		__func__, connected);
-}
-
-static struct t_usb_status_notifier usb_notifier = {
-	.name = "usb_connected",
-	.func = usb_notify_connected,
-};
-#endif /* MSM_HSUSB_SHOW_USB_NOTIFIER_MESSAGE */
-/* END: add usb_connected notify behavior ===== */
-
 static irqreturn_t usb_interrupt(int irq, void *data)
 {
 	struct usb_info *ui = data;
@@ -1015,10 +979,8 @@ static irqreturn_t usb_interrupt(int irq, void *data)
 			 */
 			set_configuration(ui);
 		}
-		if (atomic_read(&atomic_usb_connected) == 0)	{
-			atomic_set(&atomic_usb_connected, 1);
-			schedule_work(&usb_connect_notifier_wq);
-		}
+		if (msm_usb_get_connect_status() == 0)
+			msm_usb_set_connect_status(1);
 	}
 
 	if (n & STS_SLI)
@@ -1054,7 +1016,7 @@ static ssize_t show_usb_cable_connect(struct device *dev,
 		char *buf)
 {
 	unsigned length;
-	length = sprintf(buf, "%d", atomic_read(&atomic_usb_connected));
+	length = sprintf(buf, "%d", msm_usb_get_connect_status());
 	return length;
 }
 
@@ -1065,7 +1027,8 @@ static char mfg_df_serialno[16];
 static const char dummy_str[] = "000000000000";
 /* Assign serial number 0 under DIAG mode */
 static char g_normal_serialno[16];
-
+int g_bUsbDiagMode = 0;
+EXPORT_SYMBOL(g_bUsbDiagMode);
 
 static ssize_t show_usb_serial_number(struct device *dev,
 		struct device_attribute *attr,
@@ -1233,7 +1196,7 @@ static ssize_t store_usb_function_switch(struct device *dev,
 static DEVICE_ATTR(usb_function_switch, 0666,
 	show_usb_function_switch, store_usb_function_switch);
 
-static void usb_prepare(struct usb_info *ui)
+static int usb_prepare(struct usb_info *ui)
 {
 	int ret = -1;
 
@@ -1253,33 +1216,41 @@ static void usb_prepare(struct usb_info *ui)
 	ui->ep0out.max_pkt = 64;
 
 	ui->setup_req = usb_ept_alloc_req(&ui->ep0in, SETUP_BUF_SIZE);
+	if (ui->setup_req == NULL)
+		goto setup_req_fail;
 
 	INIT_WORK(&ui->work, usb_do_work);
-
-#ifdef MSM_HSUSB_SHOW_USB_NOTIFIER_MESSAGE
-	usb_register_notifier(&usb_notifier);
-#endif
-	INIT_WORK(&usb_connect_notifier_wq, send_usb_connect_notify);
-
 	ret = device_create_file(&ui->pdev->dev,
 		&dev_attr_usb_cable_connect);
 	if (ret != 0)
-		printk(KERN_WARNING "dev_attr_usb_cable_connect failed\n");
+		goto create_cable_connect_fail;
 
 	ret = device_create_file(&ui->pdev->dev,
 		&dev_attr_usb_serial_number);
 	if (ret != 0)
-		printk(KERN_WARNING "dev_attr_usb_serial_number failed\n");
+		goto create_usb_serial_number_fail;
 
 	ret = device_create_file(&ui->pdev->dev,
 		&dev_attr_dummy_usb_serial_number);
 	if (ret != 0)
-		printk(KERN_WARNING "dev_attr_dummy_usb_serial_number failed\n");
+		goto create_dummy_usb_serial_number_fail;
 
 	ret = device_create_file(&ui->pdev->dev,
 		&dev_attr_usb_function_switch);
 	if (ret != 0)
-		printk(KERN_WARNING "dev_attr_usb_function_switch failed\n");
+		goto create_dummy_usb_function_switch_fail;
+	return 0;
+
+create_dummy_usb_function_switch_fail:
+	device_remove_file(&ui->pdev->dev, &dev_attr_usb_function_switch);
+create_dummy_usb_serial_number_fail:
+	device_remove_file(&ui->pdev->dev, &dev_attr_dummy_usb_serial_number);
+create_usb_serial_number_fail:
+	device_remove_file(&ui->pdev->dev, &dev_attr_usb_cable_connect);
+create_cable_connect_fail:
+	kfree(ui->setup_req);
+setup_req_fail:
+	return -1;
 }
 
 static void usb_suspend_phy(struct usb_info *ui)
@@ -1290,7 +1261,7 @@ static void usb_suspend_phy(struct usb_info *ui)
 	ulpi_write(ui, 1 << 6, 0x06);
 }
 
-static void usb_bind_driver(struct usb_info *ui, struct usb_function_info *fi)
+static int usb_bind_driver(struct usb_info *ui, struct usb_function_info *fi)
 {
 	struct usb_endpoint *ept;
 	struct usb_endpoint_descriptor *ed;
@@ -1299,12 +1270,12 @@ static void usb_bind_driver(struct usb_info *ui, struct usb_function_info *fi)
 	unsigned n, count;
 
 	if (func->ifc_num > 2)
-		return;
+		return -1;
 
 	count = func->ifc_ept_count;
 
 	if (count > 8)
-		return;
+		return -1;
 
 	fi->ifc[0].bLength = USB_DT_INTERFACE_SIZE;
 	fi->ifc[0].bDescriptorType = USB_DT_INTERFACE;
@@ -1331,7 +1302,7 @@ static void usb_bind_driver(struct usb_info *ui, struct usb_function_info *fi)
 			printk(KERN_WARNING
 			       "failed to allocated endpoint %d\n", n);
 			free_endpoints(ui, fi);
-			return;
+			return -1;
 		}
 		ed = &(fi->ept[n].desc);
 
@@ -1363,8 +1334,26 @@ static void usb_bind_driver(struct usb_info *ui, struct usb_function_info *fi)
 	}
 	fi->endpoints = count;
 
-	func->bind(elist, func->context);
-	printk(KERN_DEBUG "%s: %s\n", __func__, func->name);
+	printk(KERN_DEBUG "Attempting to bind function driver %s\n", func->name);
+	if (func->bind(elist, func->context)) {
+		printk(KERN_WARNING
+		       "Failed to bind function driver %s\n", func->name);
+		free_endpoints(ui, fi);
+		fi->endpoints = 0;
+		if (func->cdc_desc)
+			ui->next_ifc_num--;
+		return -1;
+	}
+
+	printk(KERN_DEBUG "Successfully bound function driver %s\n", func->name);
+	return 0;
+}
+
+static void usb_unbind_driver(struct usb_info *ui, struct usb_function_info *fi)
+{
+	fi->func->configure(0, fi->func->context);
+	fi->func->unbind(fi->func->context);
+	free_endpoints(ui, fi);
 }
 
 static void usb_reset(struct usb_info *ui)
@@ -1438,7 +1427,6 @@ static void usb_start(struct usb_info *ui)
 
 	for (i = 0; i < ui->num_funcs; i++) {
 		struct usb_function_info *fi = ui->func[i];
-		usb_bind_driver(ui, fi);
 		if (fi->endpoints)
 			count++;
 	}
@@ -1482,6 +1470,7 @@ struct usb_fi_ept *get_ept_info(const char *function)
 		return NULL;
 	return &fi->ept[0];
 }
+EXPORT_SYMBOL(get_ept_info);
 
 struct usb_interface_descriptor *get_ifc_desc(const char *function)
 {
@@ -1491,7 +1480,9 @@ struct usb_interface_descriptor *get_ifc_desc(const char *function)
 		return NULL;
 	return &fi->ifc[0];
 }
-static void usb_try_to_bind(void)
+EXPORT_SYMBOL(get_ifc_desc);
+
+static void usb_try_to_start(void)
 {
 	struct usb_info *ui = the_usb_info;
 	struct msm_hsusb_platform_data *pdata;
@@ -1515,15 +1506,32 @@ static void usb_try_to_bind(void)
 
 	/* we have found all the needed functions */
 	ui->bound = 1;
-	printk(KERN_DEBUG "%s: functions bound. starting.\n", __func__);
+	printk(KERN_DEBUG "%s: functions found. starting.\n", __func__);
 	usb_start(ui);
 }
 
 int usb_function_register(struct usb_function *driver)
 {
 	struct usb_function_info *fi;
+	struct usb_info *ui = the_usb_info;
+	struct msm_hsusb_platform_data *pdata;
 	unsigned n;
 	int ret = 0;
+	int i;
+	int wanted = 0;
+
+	/* first of all, check this function is wanted by the platform */
+	pdata = ui->pdev->dev.platform_data;
+	for (i = 0; i < pdata->num_functions; i++) {
+		if (!strcmp(pdata->functions[i], driver->name)) {
+			wanted = 1;
+			break;
+		}
+	}
+	if (!wanted) {
+		printk("Ignoring unwanted USB function %s\n", driver->name);
+		return 0;
+	}
 
 	mutex_lock(&usb_function_list_lock);
 
@@ -1537,8 +1545,15 @@ int usb_function_register(struct usb_function *driver)
 	fi->enabled = !driver->disabled;
 	list_add(&fi->list, &usb_function_list);
 
-	usb_try_to_bind();
-	printk(KERN_DEBUG "%s: %s\n", __func__, driver->name);
+	if (usb_bind_driver(ui, fi)) {
+		printk(KERN_ERR "Failed to bind USB function driver %s\n", driver->name);
+		list_del(&fi->list);
+		kfree(fi);
+		return -1;
+	}
+	mutex_unlock(&usb_function_list_lock);
+	return 0;
+
 fail:
 	mutex_unlock(&usb_function_list_lock);
 	return ret;
@@ -1549,6 +1564,7 @@ unsigned return_usb_function_enabled(const char *function)
 	struct usb_function_info *fi = usb_find_function(function);
 	return fi->enabled;
 }
+EXPORT_SYMBOL(return_usb_function_enabled);
 
 int usb_function_enable(const char *function, int enable)
 {
@@ -1563,24 +1579,7 @@ int usb_function_enable(const char *function, int enable)
 	}
 	return fi->enabled;
 }
-
-static int usb_free(struct usb_info *ui, int ret)
-{
-	if (ui->irq)
-		free_irq(ui->irq, 0);
-	if (ui->pool)
-		dma_pool_destroy(ui->pool);
-	if (ui->dma)
-		dma_free_coherent(&ui->pdev->dev, 4096, ui->buf, ui->dma);
-	if (ui->addr)
-		iounmap(ui->addr);
-	if (ui->clk)
-		clk_put(ui->clk);
-	if (ui->pclk)
-		clk_put(ui->pclk);
-	kfree(ui);
-	return ret;
-}
+EXPORT_SYMBOL(usb_function_enable);
 
 static void usb_do_work_check_vbus(struct usb_info *ui)
 {
@@ -1633,8 +1632,8 @@ static void usb_do_work(struct work_struct *w)
 				/* prevent irq context stuff from doing anything */
 				spin_lock_irqsave(&ui->lock, iflags);
 
-				if (atomic_read(&atomic_usb_connected) == 1)
-					atomic_set(&atomic_usb_connected, 0);
+				if (msm_usb_get_connect_status() == 1)
+					msm_usb_set_connect_status(0);
 
 				ui->running = 0;
 				ui->online = 0;
@@ -1852,32 +1851,100 @@ const struct file_operations debug_cycle_ops = {
 
 static void usb_debugfs_init(struct usb_info *ui)
 {
-	struct dentry *dent;
-	dent = debugfs_create_dir("usb", 0);
-	if (IS_ERR(dent))
+	ui->dent = debugfs_create_dir("usb", 0);
+	if (IS_ERR(ui->dent)) {
+		ui->dent = NULL;
 		return;
+	}
+
+	debugfs_create_file("status", 0444, ui->dent, ui, &debug_stat_ops);
+	debugfs_create_file("reset", 0222, ui->dent, ui, &debug_reset_ops);
+	debugfs_create_file("cycle", 0222, ui->dent, ui, &debug_cycle_ops);
+}
 
-	debugfs_create_file("status", 0444, dent, ui, &debug_stat_ops);
-	debugfs_create_file("reset", 0222, dent, ui, &debug_reset_ops);
-	debugfs_create_file("cycle", 0222, dent, ui, &debug_cycle_ops);
+static void usb_debugfs_shutdown(struct usb_info *ui)
+{
+        if (ui->dent)
+                debugfs_remove_recursive(ui->dent);
 }
+
 #else
 static void usb_debugfs_init(struct usb_info *ui) {}
+static void usb_debugfs_shutdown(struct usb_info *ui) {}
 #endif
 
+
+
+static int usb_remove(struct platform_device *pdev)
+{
+	unsigned long flags;
+	struct usb_info *ui = platform_get_drvdata(pdev);
+	struct list_head *entry;
+	struct list_head *temp;
+
+	/* mark us as offline */
+	spin_lock_irqsave(&ui->lock, flags);
+	ui->running = 0;
+	ui->online = 0;
+	spin_unlock_irqrestore(&ui->lock, flags);
+
+	/* shut down anything with an external trigger */
+	usb_debugfs_shutdown(ui);
+	device_remove_file(&ui->pdev->dev, &dev_attr_usb_cable_connect);
+	device_remove_file(&ui->pdev->dev, &dev_attr_usb_serial_number);
+	device_remove_file(&ui->pdev->dev, &dev_attr_dummy_usb_serial_number);
+	device_remove_file(&ui->pdev->dev, &dev_attr_usb_function_switch);
+	msm_hsusb_set_vbus_state_notifier(NULL);
+	hrtimer_cancel(&ui->vbus_timer);
+	writel(0, USB_USBINTR);
+
+	/* reset the device */
+	writel(2, USB_USBCMD);
+	msleep(10);
+
+	/* unbind function devices */
+	list_for_each_safe(entry, temp, &usb_function_list) {
+		struct usb_function_info *fi =
+			list_entry(entry, struct usb_function_info, list);
+		if (fi->func)
+			usb_unbind_driver(ui, fi);
+		list_del(entry);
+		kfree(fi);
+	}
+
+	/* finally, clean up any resources */
+	if (ui->phy_shutdown)
+		ui->phy_shutdown();
+	do_free_req(ui, to_msm_request(ui->setup_req));
+	disable_irq_wake(ui->irq);
+	free_irq(ui->irq, ui);
+	dma_pool_destroy(ui->pool);
+	dma_free_coherent(&ui->pdev->dev, 4096, ui->buf, ui->dma);
+	iounmap(ui->addr);
+	clk_put(ui->clk);
+	clk_put(ui->pclk);
+	if (ui->func)
+		kfree(ui->func);
+	kfree(ui);
+	return 0;
+}
+
+
+
+
 static int usb_probe(struct platform_device *pdev)
 {
 	struct resource *res;
 	struct usb_info *ui;
-	int irq;
 	int ret;
 
 	ui = kzalloc(sizeof(struct usb_info), GFP_KERNEL);
 	if (!ui)
-		return -ENOMEM;
+		goto alloc_fail;
 
 	spin_lock_init(&ui->lock);
 	ui->pdev = pdev;
+	platform_set_drvdata(pdev, ui);
 
 	if (pdev->dev.platform_data) {
 		struct msm_hsusb_platform_data *pdata = pdev->dev.platform_data;
@@ -1898,58 +1965,55 @@ static int usb_probe(struct platform_device *pdev)
 
 		ui->func = kzalloc(sizeof(struct usb_function *) *
 				   pdata->num_functions, GFP_KERNEL);
+		if (ui->func == NULL)
+			goto func_alloc_fail;
 
 		pdata = ui->pdev->dev.platform_data;
 		strncpy(g_normal_serialno,
 			pdata->serial_number, strlen(pdata->serial_number));
-
-		if (!ui->func) {
-			kfree(ui);
-			return -ENOMEM;
-		}
 	}
 
-	irq = platform_get_irq(pdev, 0);
+	ui->irq = platform_get_irq(pdev, 0);
 	res = platform_get_resource(pdev, IORESOURCE_MEM, 0);
-	if (!res || (irq < 0))
-		return usb_free(ui, -ENODEV);
+	if (!res || (ui->irq < 0))
+		goto get_resources_fail;
 
 	ui->addr = ioremap(res->start, 4096);
 	if (!ui->addr)
-		return usb_free(ui, -ENOMEM);
+		goto ioremap_fail;
 
 	ui->buf = dma_alloc_coherent(&pdev->dev, 4096, &ui->dma, GFP_KERNEL);
 	if (!ui->buf)
-		return usb_free(ui, -ENOMEM);
+		goto dma_alloc_fail;
 
 	ui->pool = dma_pool_create("hsusb", NULL, 32, 32, 0);
 	if (!ui->pool)
-		return usb_free(ui, -ENOMEM);
+		goto pool_create_fail;
 
 	printk(KERN_INFO "usb_probe() io=%p, irq=%d, dma=%p(%x)\n",
-	       ui->addr, irq, ui->buf, ui->dma);
+	       ui->addr, ui->irq, ui->buf, ui->dma);
 
 	ui->clk = clk_get(&pdev->dev, "usb_hs_clk");
 	if (IS_ERR(ui->clk))
-		return usb_free(ui, PTR_ERR(ui->clk));
+		goto hs_clk_get_fail;
 
 	ui->pclk = clk_get(&pdev->dev, "usb_hs_pclk");
 	if (IS_ERR(ui->pclk))
-		return usb_free(ui, PTR_ERR(ui->pclk));
+		goto hs_pclk_get_fail;
 
-	ret = request_irq(irq, usb_interrupt, 0, pdev->name, ui);
+	ret = request_irq(ui->irq, usb_interrupt, 0, pdev->name, ui);
 	if (ret)
-		return usb_free(ui, ret);
-	enable_irq_wake(irq);
-	ui->irq = irq;
+		goto request_irq_fail;
+	enable_irq_wake(ui->irq);
 
 	the_usb_info = ui;
 
 	usb_debugfs_init(ui);
 
-	usb_prepare(ui);
+	if (usb_prepare(ui))
+		goto usb_prepare_fail;
 
-	 perf_lock_init(&usb_perf_lock, PERF_LOCK_HIGHEST, "usb");
+	perf_lock_init(&usb_perf_lock, PERF_LOCK_HIGHEST, "usb");
 
 	/* initialize mfg serial number */
 	usb_setting_serial_number_mfg = 0;
@@ -1957,22 +2021,154 @@ static int usb_probe(struct platform_device *pdev)
 
 	hrtimer_init(&ui->vbus_timer, CLOCK_MONOTONIC, HRTIMER_MODE_REL);
 	ui->vbus_timer.function = vbus_polling_timer_func ;
-
+	msm_hsusb_set_vbus_state_notifier(&msm_hsusb_set_vbus_state);
 	return 0;
+
+usb_prepare_fail:
+	free_irq(ui->irq, ui);
+request_irq_fail:
+	clk_put(ui->pclk);
+hs_pclk_get_fail:
+	clk_put(ui->clk);
+hs_clk_get_fail:
+	dma_pool_destroy(ui->pool);
+pool_create_fail:
+	dma_free_coherent(&ui->pdev->dev, 4096, ui->buf, ui->dma);
+dma_alloc_fail:
+	iounmap(ui->addr);
+ioremap_fail:
+get_resources_fail:
+	if (ui->func)
+		kfree(ui->func);
+func_alloc_fail:
+	kfree(ui);
+alloc_fail:
+	printk(KERN_ERR "msm_hsusb_probe failed\n");
+	return -ENOMEM;
 }
 
 static struct platform_driver usb_driver = {
 	.probe = usb_probe,
+	.remove = usb_remove,
 	.driver = { .name = "msm_hsusb", },
 };
 
+#ifdef CONFIG_USB_FUNCTION_NULL
+extern void null_init(void);
+#endif
+#ifdef CONFIG_USB_FUNCTION_ZERO
+extern void zero_init(void);
+#endif
+#ifdef CONFIG_USB_FUNCTION_LOOPBACK
+extern void loopback_init(void);
+#endif
+#ifdef CONFIG_USB_FUNCTION_ADB
+extern void adb_init(void);
+#endif
+#ifdef CONFIG_USB_FUNCTION_UMS
+extern void ums_init(void);
+#endif
+#ifdef CONFIG_USB_FUNCTION_MASS_STORAGE
+extern void fsg_init(void);
+extern void fsg_exit(void);
+#endif
+#ifdef CONFIG_USB_FUNCTION_DIAG
+extern void diag_init(void);
+extern void diag_exit(void);
+#endif
+#ifdef CONFIG_USB_FUNCTION_ETHER
+extern void ether_init(void);
+extern void ether_exit(void);
+#endif
+#ifdef CONFIG_USB_FUNCTION_SERIAL
+extern void fs_init(void);
+extern void fs_exit(void);
+#endif
+#ifdef CONFIG_USB_FUNCTION_FSYNC
+extern void fsync_init(void);
+extern void fsync_exit(void);
+#endif
+#ifdef CONFIG_USB_FUNCTION_MTP_TUNNEL
+extern void mtp_tunnel_init(void);
+extern void mtp_tunnel_exit(void);
+#endif
+
+static void __exit usb_exit(void)
+{
+	platform_driver_unregister(&usb_driver);
+#ifdef CONFIG_USB_FUNCTION_MASS_STORAGE
+	fsg_exit();
+#endif
+#ifdef CONFIG_USB_FUNCTION_DIAG
+	diag_exit();
+#endif
+#ifdef CONFIG_USB_FUNCTION_ETHER
+	ether_exit();
+#endif
+#ifdef CONFIG_USB_FUNCTION_SERIAL
+	fs_exit();
+#endif
+#ifdef CONFIG_USB_FUNCTION_FSYNC
+	fsync_exit();
+#endif
+#ifdef CONFIG_USB_FUNCTION_MTP_TUNNEL
+	mtp_tunnel_exit();
+#endif
+}
+
+module_exit(usb_exit);
+
 static int __init usb_init(void)
 {
-	return platform_driver_register(&usb_driver);
+	int ret;
+
+	if ((ret = platform_driver_register(&usb_driver)) < 0)
+		return ret;
+
+#ifdef CONFIG_USB_FUNCTION_NULL
+	null_init();
+#endif
+#ifdef CONFIG_USB_FUNCTION_ZERO
+	zero_init();
+#endif
+#ifdef CONFIG_USB_FUNCTION_LOOPBACK
+	loopback_init();
+#endif
+#ifdef CONFIG_USB_FUNCTION_ADB
+	adb_init();
+#endif
+#ifdef CONFIG_USB_FUNCTION_UMS
+	ums_init();
+#endif
+#ifdef CONFIG_USB_FUNCTION_MASS_STORAGE
+	fsg_init();
+#endif
+#ifdef CONFIG_USB_FUNCTION_DIAG
+	diag_init();
+#endif
+#ifdef CONFIG_USB_FUNCTION_ETHER
+	ether_init();
+#endif
+#ifdef CONFIG_USB_FUNCTION_SERIAL
+	fs_init();
+#endif
+#ifdef CONFIG_USB_FUNCTION_FSYNC
+	fsync_init();
+#endif
+#ifdef CONFIG_USB_FUNCTION_MTP_TUNNEL
+	mtp_tunnel_init();
+#endif
+	usb_try_to_start();
+
+	return 0;
 }
 
 module_init(usb_init);
 
+MODULE_DESCRIPTION("MSM 72K USB Function Controller");
+MODULE_AUTHOR("Mike Lockwood, Brian Swetland");
+MODULE_LICENSE("GPL");
+
 static void copy_string_descriptor(char *string, char *buffer)
 {
 	int length, i;
diff --git a/drivers/usb/function/mtp_tunnel.c b/drivers/usb/function/mtp_tunnel.c
index df84844..9935321 100644
--- a/drivers/usb/function/mtp_tunnel.c
+++ b/drivers/usb/function/mtp_tunnel.c
@@ -113,6 +113,7 @@ struct mtp_tunnel_context
 };
 
 static struct mtp_tunnel_context _context;
+static int cleanup;
 
 struct _mtp_specific_request {
 	//unsigned char request_specific_sequence;
@@ -610,8 +611,11 @@ static void mtp_tunnel_unbind(void *_ctxt)
 	struct mtp_tunnel_context *ctxt = _ctxt;
 	struct usb_request *req;
 
-	printk(KERN_DEBUG "mtp_tunnel_unbind()\n");
-
+	if (ctxt->read_req)
+		usb_ept_free_req(ctxt->out, ctxt->read_req);
+	while ((req = req_get(ctxt, &ctxt->rx_done))) {
+		usb_ept_free_req(ctxt->out, req);
+	}
 	while ((req = req_get(ctxt, &ctxt->rx_idle))) {
 		usb_ept_free_req(ctxt->out, req);
 	}
@@ -621,18 +625,19 @@ static void mtp_tunnel_unbind(void *_ctxt)
 
 	ctxt->online = 0;
 	ctxt->error = 1;
-
-	if (ctxt->registered)	{
-		device_remove_file(&mtp_tunnel_dev, &dev_attr_mtp_tunnel_status);
-		device_unregister(&mtp_tunnel_dev);
-		ctxt->registered = 0;
-		}
 	
 	/* readers may be blocked waiting for us to go online */
 	wake_up(&ctxt->read_wq);
+	wake_up(&ctxt->write_wq);
+
+	device_remove_file(&mtp_tunnel_dev, &dev_attr_mtp_tunnel_status);
+	device_unregister(&mtp_tunnel_dev);
+
+	misc_deregister(&mtp_tunnel_device);
+	misc_deregister(&mtp_tunnel_enable_device);
 }
 
-static void mtp_tunnel_bind(struct usb_endpoint **ept, void *_ctxt)
+static int mtp_tunnel_bind(struct usb_endpoint **ept, void *_ctxt)
 {
 	struct mtp_tunnel_context *ctxt = _ctxt;
 	struct usb_request *req;
@@ -640,6 +645,7 @@ static void mtp_tunnel_bind(struct usb_endpoint **ept, void *_ctxt)
 #ifndef ALLOCATE_16K_BUFF
 	int n;
 #endif
+
 	ctxt->registered = 0;
 	ctxt->out = ept[0];
 	ctxt->in = ept[1];
@@ -651,7 +657,7 @@ static void mtp_tunnel_bind(struct usb_endpoint **ept, void *_ctxt)
 #endif
 	{
 		req = usb_ept_alloc_req(ctxt->out, TXN_MAX);
-		if (req == 0) goto fail;
+		if (req == 0) goto rx_idle_fail;
 		req->context = ctxt;
 		req->complete = mtp_tunnel_complete_out;
 		req_put(ctxt, &ctxt->rx_idle, req);
@@ -663,23 +669,16 @@ static void mtp_tunnel_bind(struct usb_endpoint **ept, void *_ctxt)
 #endif
 	{
 		req = usb_ept_alloc_req(ctxt->in, TXN_MAX);
-		if (req == 0) goto fail;
+		if (req == 0) goto tx_idle_fail;
 		req->context = ctxt;
 		req->complete = mtp_tunnel_complete_in;
 		req_put(ctxt, &ctxt->tx_idle, req);
 	}
 
-#ifndef ALLOCATE_16K_BUFF
-	printk(KERN_DEBUG
-	       "mtp_tunnel_bind() allocated %d rx and %d tx requests\n",
-	       RX_REQ_MAX, TX_REQ_MAX);
-#else
-	printk(KERN_DEBUG
-		"%s(): allocated buffer: %d\n", __func__, TXN_MAX);
-#endif
-
-	misc_register(&mtp_tunnel_device);
-	misc_register(&mtp_tunnel_enable_device);
+	if (misc_register(&mtp_tunnel_device))
+		goto misc_register_1_fail;
+	if (misc_register(&mtp_tunnel_enable_device))
+		goto misc_register_2_fail;
 
 	mtp_tunnel_dev.release = mtp_tunnel_dev_release;
 	mtp_tunnel_dev.parent = &ctxt->pdev->dev;
@@ -688,23 +687,42 @@ static void mtp_tunnel_bind(struct usb_endpoint **ept, void *_ctxt)
 	ret = device_register(&mtp_tunnel_dev);
 	if (ret != 0) {
 		printk(KERN_WARNING "mtp_tunnel_dev failed to register device: %d\n", ret);
-		goto fail_dev_register_fail;
+		goto device_register_fail;
 	}
 	ret = device_create_file(&mtp_tunnel_dev, &dev_attr_mtp_tunnel_status);
 	if (ret != 0) {
 		printk(KERN_WARNING "mtp_tunnel_dev device_create_file failed: %d\n", ret);
-		device_unregister(&mtp_tunnel_dev);
-		goto fail_dev_register_fail;
+		goto device_create_file_fail;
 	}
-	ctxt->registered = 1;
-	return;
 
-fail_dev_register_fail:
-	printk(KERN_ERR "%s() could not allocate requests\n", __func__);
+	ctxt->registered = 1;
+#ifndef ALLOCATE_16K_BUFF
+	printk(KERN_DEBUG
+	       "mtp_tunnel_bind() allocated %d rx and %d tx requests\n",
+	       RX_REQ_MAX, TX_REQ_MAX);
+#else
+	printk(KERN_DEBUG
+		"%s(): allocated buffer: %d\n", __func__, TXN_MAX);
+#endif
+	return 0;
 
-fail:
+device_create_file_fail:
+	device_unregister(&mtp_tunnel_dev);
+device_register_fail:
+	misc_register(&mtp_tunnel_enable_device);
+misc_register_2_fail:
+	misc_deregister(&mtp_tunnel_device);
+misc_register_1_fail:
+tx_idle_fail:
+	while ((req = req_get(ctxt, &ctxt->tx_idle))) {
+		usb_ept_free_req(ctxt->in, req);
+	}
+rx_idle_fail:
+	while ((req = req_get(ctxt, &ctxt->rx_idle))) {
+		usb_ept_free_req(ctxt->out, req);
+	}
 	printk(KERN_WARNING "mtp_tunnel_bind() could not allocate requests\n");
-	mtp_tunnel_unbind(ctxt);
+	return -1;
 }
 
 static void mtp_tunnel_configure(int configured, void *_ctxt)
@@ -824,7 +842,7 @@ static struct usb_function usb_func_mtp_tunnel = {
 	.ifc_index = STRING_MTP,
 };
 
-static int __init mtp_tunnel_init(void)
+void mtp_tunnel_init(void)
 {
 	struct mtp_tunnel_context *ctxt = &_context;
 	int retval;
@@ -848,16 +866,28 @@ static int __init mtp_tunnel_init(void)
 	INIT_LIST_HEAD(&ctxt->tx_idle);
 	retval = platform_driver_register (&mtp_tunnel_driver);
 	if (retval < 0)
-		return retval;
+		goto platform_driver_register_fail;
 	retval = platform_device_register (&mtp_tunnel_device_register);
 	if (retval < 0)
-		goto err_register_device;
-
-	return usb_function_register(&usb_func_mtp_tunnel);
+		goto platform_device_register_fail;
+	retval = usb_function_register(&usb_func_mtp_tunnel);
+	if (retval)
+		goto usb_function_register_fail;
+	cleanup = 1;
+	return;
 
-err_register_device:
+usb_function_register_fail:
+	platform_device_unregister(&mtp_tunnel_device_register);
+platform_device_register_fail:
 	platform_driver_unregister(&mtp_tunnel_driver);
-	return retval;
+platform_driver_register_fail:
+	return;
 }
 
-module_init(mtp_tunnel_init);
+void mtp_tunnel_exit(void)
+{
+	if (cleanup) {
+		platform_driver_unregister(&mtp_tunnel_driver);
+		platform_device_unregister(&mtp_tunnel_device_register);
+	}
+}
diff --git a/drivers/usb/function/null.c b/drivers/usb/function/null.c
index 68f1e35..d3b425a 100644
--- a/drivers/usb/function/null.c
+++ b/drivers/usb/function/null.c
@@ -31,20 +31,28 @@ struct null_context
 
 static struct null_context _context;
 
-static void null_bind(struct usb_endpoint **ept, void *_ctxt)
+static int null_bind(struct usb_endpoint **ept, void *_ctxt)
 {
 	struct null_context *ctxt = _ctxt;
 	ctxt->out = ept[0];
-	printk(KERN_INFO "null_bind() %p\n", ctxt->out);
 
-	ctxt->req0 = usb_ept_alloc_req(ctxt->out, 4096);
-	ctxt->req1 = usb_ept_alloc_req(ctxt->out, 4096);
+	if ((ctxt->req0 = usb_ept_alloc_req(ctxt->out, 4096)) == NULL)
+		goto req0_fail;
+	if ((ctxt->req1 = usb_ept_alloc_req(ctxt->out, 4096)) == NULL)
+		goto req1_fail;
+	return 0;
+
+req1_fail:
+	usb_ept_free_req(ctxt->out, ctxt->req0);
+req0_fail:
+	printk(KERN_WARNING "null_bind() could not allocate requests\n");
+	return -1;
 }
 
 static void null_unbind(void *_ctxt)
 {
 	struct null_context *ctxt = _ctxt;
-	printk(KERN_INFO "null_unbind()\n");
+
 	if (ctxt->req0) {
 		usb_ept_free_req(ctxt->out, ctxt->req0);
 		ctxt->req0 = 0;
@@ -62,7 +70,6 @@ static void null_queue_out(struct null_context *ctxt, struct usb_request *req);
 static void null_out_complete(struct usb_endpoint *ept, struct usb_request *req)
 {
 	struct null_context *ctxt = req->context;
-	unsigned char *data = req->buf;
 
 	if (req->status != -ENODEV)
 		null_queue_out(ctxt, req);
@@ -108,11 +115,7 @@ static struct usb_function usb_func_null = {
 	.ifc_ept_type = { EPT_BULK_OUT },
 };
 
-static int __init null_init(void)
+void null_init(void)
 {
-	printk(KERN_INFO "null_init()\n");
-	usb_function_register(&usb_func_null);
-	return 0;
+       usb_function_register(&usb_func_null);
 }
-
-module_init(null_init);
diff --git a/drivers/usb/function/rndis.c b/drivers/usb/function/rndis.c
index 3d03664..cfa0437 100644
--- a/drivers/usb/function/rndis.c
+++ b/drivers/usb/function/rndis.c
@@ -1403,7 +1403,7 @@ static struct proc_dir_entry *rndis_connect_state [RNDIS_MAX_CONFIGS];
 #endif	/* CONFIG_USB_GADGET_DEBUG_FILES */
 
 
-int __devinit rndis_init (void)
+int rndis_init (void)
 {
 	u8 i;
 
diff --git a/drivers/usb/function/ums.c b/drivers/usb/function/ums.c
index 59621a5..ea91b28 100644
--- a/drivers/usb/function/ums.c
+++ b/drivers/usb/function/ums.c
@@ -332,12 +332,12 @@ static struct miscdevice ums_device = {
 	.fops = &ums_fops,
 };
 
-static void ums_bind(struct usb_endpoint **ept, void *_ctxt)
+static int ums_bind(struct usb_endpoint **ept, void *_ctxt)
 {
 	struct ums_context *ctxt = _ctxt;
 	struct usb_request *req;
 	int n;
-	
+
 	ctxt->out = ept[0];
 	ctxt->in = ept[1];
 
@@ -345,7 +345,7 @@ static void ums_bind(struct usb_endpoint **ept, void *_ctxt)
 	
 	for(n = 0; n < RX_REQ_MAX; n++) {
 		req = usb_ept_alloc_req(ctxt->out, 4096);
-		if(req == 0) goto fail;
+		if(req == 0) goto rx_idle_fail;
 		req->context = ctxt;
 		req->complete = ums_complete_out;
 		req_put(ctxt, &ctxt->rx_idle, req);
@@ -353,22 +353,58 @@ static void ums_bind(struct usb_endpoint **ept, void *_ctxt)
 
 	for(n = 0; n < TX_REQ_MAX; n++) {
 		req = usb_ept_alloc_req(ctxt->in, 4096);
-		if(req == 0) goto fail;
+		if(req == 0) goto tx_idle_fail;
 		req->context = ctxt;
 		req->complete = ums_complete_in;
 		req_put(ctxt, &ctxt->tx_idle, req);
 	}
 
+	if (misc_register(&ums_device))
+		goto misc_register_fail;
+
 	printk("ums_bind() allocated %d rx and %d tx requests\n",
 	       RX_REQ_MAX, TX_REQ_MAX);
-	
-	misc_register(&ums_device);
-	return;
-	
-fail:
+	return 0;
+
+misc_register_fail:
+tx_idle_fail:
+        while ((req = req_get(ctxt, &ctxt->tx_idle))) {
+                usb_ept_free_req(ctxt->in, req);
+        }
+rx_idle_fail:
+	while ((req = req_get(ctxt, &ctxt->rx_idle))) {
+                usb_ept_free_req(ctxt->out, req);
+        }
 	printk("ums_bind() could not allocate requests\n");
+	return -1;
+}
+
+static void ums_unbind(void *_ctxt)
+{
+	struct ums_context *ctxt = _ctxt;
+	struct usb_request *req;
 
-	/* XXX release any we did allocate */
+	if(ctxt->read_req) {
+		usb_ept_free_req(ctxt->out, ctxt->read_req);
+		ctxt->read_req = 0;
+	}
+	while((req = req_get(ctxt, &ctxt->rx_done))) {
+		usb_ept_free_req(ctxt->out, req);
+	}
+	while ((req = req_get(ctxt, &ctxt->rx_idle))) {
+                usb_ept_free_req(ctxt->out, req);
+        }
+        while ((req = req_get(ctxt, &ctxt->tx_idle))) {
+                usb_ept_free_req(ctxt->in, req);
+        }
+
+	ctxt->online = 0;
+	ctxt->error = 1;
+
+	wake_up(&ctxt->read_wq);
+	wake_up(&ctxt->write_wq);
+
+	misc_deregister(&ums_device);
 }
 
 static int ums_setup(struct usb_ctrlrequest* req, void* buf, int len, void *_ctxt)
@@ -429,6 +465,7 @@ static void ums_configure(int configured, void *_ctxt)
 
 static struct usb_function usb_func_ums = {
 	.bind = ums_bind,
+	.unbind = ums_unbind,
 	.configure = ums_configure,
 	.setup = ums_setup,
 
@@ -447,7 +484,7 @@ static struct usb_function usb_func_ums = {
 	.ifc_num = 1,
 };
 
-static int __init ums_init(void)
+void ums_init(void)
 {
 	struct ums_context *ctxt = &_context;
 	DBG("ums_init()\n");
@@ -460,12 +497,10 @@ static int __init ums_init(void)
 	atomic_set(&ctxt->open_excl, 0);
 	atomic_set(&ctxt->read_excl, 0);
 	atomic_set(&ctxt->write_excl, 0);
-	
+
 	INIT_LIST_HEAD(&ctxt->rx_idle);
 	INIT_LIST_HEAD(&ctxt->rx_done);
 	INIT_LIST_HEAD(&ctxt->tx_idle);
-	
-	return usb_function_register(&usb_func_ums);
-}
 
-module_init(ums_init);
+	usb_function_register(&usb_func_ums);
+}
